#include "../include/status.h"
#include "../include/string.h"
#include "../include/command.h"

void checkSystemd()
{
	std::vector<std::string> systemctl = splitString(exec("systemctl --state=failed"), '\n');
	std::vector<std::string> failedUnits;
	std::vector<int> vectorService;
	bool foundErrors = false;

	for (unsigned int i{0}; i < systemctl.size(); i++)
	{
		if (findString(systemctl[i],"failed"))
		{
			failedUnits.push_back(systemctl[i]);
			foundErrors = true;
		}
	}

	for (unsigned int i{0}; i < failedUnits.size(); i++)
	{
		vectorService = findDelim(failedUnits[i],' ');
		// Doing math on vectorService to remove the spaces from the name
		failedUnits[i] = stringRange(failedUnits[i],vectorService[0]+1,vectorService[1]-1);
	}

	if (foundErrors == true)
	{
		std::cout << "[FAILED SYSTEMD UNITS]" << std::endl;
		for (unsigned int i{0}; i < failedUnits.size(); i++)
		{
			std::cout << failedUnits[i] << std::endl;
		}
		std::cout << std::endl;
	}
}

void checkDisk(int threshold)
{
	std::vector<std::string> diskUsage = splitString(exec("df -h"),'\n');
	std::vector<std::string> diskUsageTemp;
	std::vector<std::string> diskThreshold;
	bool foundError = false;

	// Iterate over the disks
	for (unsigned int i {1}; i < diskUsage.size(); i++)
	{
		diskUsageTemp = splitString(diskUsage[i],' ');
		for (unsigned int x {0}; x < diskUsageTemp.size(); x++)
		{
			if (findString(diskUsageTemp[x],"%") == true)
			{
				diskUsageTemp[x].pop_back();
				if(std::stoi(diskUsageTemp[x]) >= threshold)
				{
					diskThreshold.push_back(diskUsageTemp[0] + " " + diskUsageTemp[x] + "%" + " " + diskUsageTemp[x+1]);
					foundError = true;
				}
			}
		}
	}

	if (foundError == true)
	{
		std::cout << "[DISK USAGE]" << std::endl;
		for (unsigned int i{0}; i < diskThreshold.size(); i++)
		{
			std::cout << diskThreshold[i] << std::endl;
		}
		std::cout << std::endl;
	}
}

void checkDmesg()
{
	bool dmesgErr = false;
	std::string errMsg;

	while (dmesgErr == false)
	{
		if (exec("dmesg -l emerg").size())
		{
			errMsg = "CRITICAL ERRORS! SYSTEM UNSTABLE!";
			dmesgErr = true;
		}
		if (exec("dmesg -l alert").size())
		{
			errMsg = "ALERT! Take action immediately";
			dmesgErr = true;
		}
		if (exec("dmesg -l crit").size())
		{
			errMsg = "System in critical condidition";
			dmesgErr = true;
		}
		if (exec("dmesg -l err").size())
		{
			errMsg = "Errors are present in kernel ring buffer";
			dmesgErr = true;
		}
		break;
	}

	if (dmesgErr == true)
	{
		std::cout << "[DMESG]" << std::endl;
		std::cout << errMsg << std::endl;
	}
}
